; c2h8/theme.jl

;; Copyright (C) 1999 Jess Bravo lvarez <jba@pobox.com>

;; This is a port of the enlightenment theme with the same name, made
;; by Markus Kniebes <m.kniebes@c2h8.de>

(let*

  (

;; the font

    (font "-*-helvetica-medium-r-normal-*-12-*-*-*-p-*-iso8859-1")

;; images

    (title-bar-images (set-image-border
                      (make-image "titelleiste.png") 4 4 0 0))
    (down-title-bar-images (set-image-border
                           (make-image "ziehleiste_oben.png") 4 4 0 0))
    (button-bar-images (set-image-border
                       (make-image "knopfleiste.png") 4 4 0 0))

    (t-title-images (make-image "b.png"))

    (left-border-images (set-image-border (make-image "links2.png") 0 0 4 0))
    (t-left-border-images (make-image "d.png"))

    (right-border-images (make-image "rechts.png"))
    (t-right-border-images (make-image "e.png"))

    (bottom-border-images (make-image "unten.png"))
    (t-bottom-border-images (make-image "g.png"))

    (top-left-images (make-image "links1.png"))
    (t-top-left-images (make-image "a.png"))
    (st-top-left-images (make-image "a-.png"))

    (top-right-images (make-image "oben_rechts.png"))
    (t-top-right-images (make-image "c.png"))
    (st-top-right-images (make-image "c-.png"))

    (bottom-left-images (make-image "unten_links.png"))
    (t-bottom-left-images (make-image "f.png"))
    
    (bottom-right-images (make-image "unten_rechts.png"))
    (t-bottom-right-images (make-image "h.png"))

    (iconify-images (list (make-image "icon1.png") nil
                          (make-image "icon2.png")
                          (make-image "icon3.png")))

    (maximize-images (list (make-image "system1.png") nil
                           (make-image "system2.png")
                           (make-image "system3.png")))

    (close-images (list (make-image "kill1.png") nil
                        (make-image "kill2.png")
                        (make-image "kill3.png")))

;; frame layout

    (frame
     `(

    ;; title

        ((background . ,title-bar-images)
         (foreground . ("gray" "white"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 6)
         (y-justify . center)
         (top-edge . -24)
         (left-edge . -12)
         (right-edge . 62)
         (class . title)
        )

        ((background . ,down-title-bar-images)
         (top-edge . -4)
         (left-edge . 0)
         (right-edge . 62)
         (class . title)
        )

        ((background . ,button-bar-images)
         (top-edge . -19)
         (right-edge . 0)
         (class . title)
        )

    ;; left border

        ((background . ,left-border-images)
         (top-edge . -4)
         (bottom-edge . 0)
         (left-edge . -7)
         (class . left-border)
        )

    ;; top-left corner

        ((background . ,top-left-images)
         (top-edge . -4)
         (left-edge . -12)
         (class . title)
        )

    ;; right border

        ((background . ,right-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -6)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,bottom-border-images)
         (bottom-edge . -8)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; top-right corner

        ((background . ,top-right-images)
         (top-edge . -19)
         (right-edge . -6)
         (class . top-right-corner)
        )

    ;; bottom-left corner

        ((background . ,bottom-left-images)
         (bottom-edge . -8)
         (left-edge . -9)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,bottom-right-images)
         (bottom-edge . -8)
         (right-edge . -6)
         (class . bottom-right-corner)
        )

    ;; iconify button

        ((background . ,iconify-images)
         (top-edge . -16)
         (right-edge . 35)
         (class . iconify-button)
        )

    ;; maximize button

        ((background . ,maximize-images)
         (top-edge . -16)
         (right-edge . 21)
         (class . maximize-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -16)
         (right-edge . 7)
         (class . close-button)
        )

      )
    )

    (shaped-frame
     `(

    ;; title

        ((background . ,title-bar-images)
         (foreground . ("gray" "white"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 6)
         (y-justify . center)
         (top-edge . -24)
         (left-edge . -12)
         (right-edge . ,(lambda (w) (- (car (window-dimensions w)) 38)))
         (class . title)
        )

    ;; top-left corner

        ((background . ,top-left-images)
         (top-edge . -4)
         (left-edge . -12)
         (class . title)
        )

      )
    )

    (transient-frame
     `(

    ;; title

        ((background . ,t-title-images)
         (top-edge . -15)
         (left-edge . 0)
         (right-edge . 0)
         (class . title)
        )

    ;; left border

        ((background . ,t-left-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (left-edge . -9)
         (class . left-border)
        )

    ;; right border

        ((background . ,t-right-border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -8)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,t-bottom-border-images)
         (bottom-edge . -8)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; top-left corner

        ((background . ,t-top-left-images)
         (top-edge . -15)
         (left-edge . -9)
         (class . title)
        )

    ;; top-right corner

        ((background . ,t-top-right-images)
         (top-edge . -15)
         (right-edge . -8)
         (class . top-right-corner)
        )

    ;; bottom-left corner

        ((background . ,t-bottom-left-images)
         (bottom-edge . -8)
         (left-edge . -9)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,t-bottom-right-images)
         (bottom-edge . -8)
         (right-edge . -8)
         (class . bottom-right-corner)
        )

      )
    )

    (shaped-transient-frame
     `(

    ;; title

        ((background . ,t-title-images)
         (top-edge . -15)
         (left-edge . 0)
         (right-edge . 0)
         (class . title)
        )

    ;; top-left corner

        ((background . ,st-top-left-images)
         (top-edge . -15)
         (left-edge . -9)
         (class . title)
        )

    ;; top-right corner

        ((background . ,st-top-right-images)
         (top-edge . -15)
         (right-edge . -8)
         (class . top-right-corner)
        )

      )
    )

  )

;; frame definition

  (add-frame-style 'c2h8
    (lambda (w type)
      (case type
            ((default) frame)
            ((transient) transient-frame)
            ((shaped) shaped-frame)
            ((shaped-transient) shaped-transient-frame)
      )
    )
  )

)
